'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _raxScrollview = require('rax-scrollview');

var _raxScrollview2 = _interopRequireDefault(_raxScrollview);

var _raxText = require('rax-text');

var _raxText2 = _interopRequireDefault(_raxText);

var _raxView = require('rax-view');

var _raxView2 = _interopRequireDefault(_raxView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_HEIGHT = 480;

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    _classCallCheck(this, Table);

    return _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).apply(this, arguments));
  }

  _createClass(Table, [{
    key: '_renderCell',
    value: function _renderCell(cellData, col) {
      var width = col.width || this.props.columnWidth;
      var style = {};
      if (width) {
        style.width = width;
      } else {
        style.flex = 1;
      }

      return (0, _rax.createElement)(
        _raxView2.default,
        { key: col.dataIndex, style: [styles.tableCell, style] },
        (0, _rax.createElement)(
          _raxText2.default,
          null,
          cellData
        )
      );
    }
  }, {
    key: '_renderHeader',
    value: function _renderHeader() {
      var _props = this.props,
          columns = _props.columns,
          columnWidth = _props.columnWidth;

      return columns.map(function (col, index) {
        var width = col.width || columnWidth;
        var style = {};
        if (width) {
          style.width = width;
        } else {
          style.flex = 1;
        }

        return (0, _rax.createElement)(
          _raxView2.default,
          { key: index, style: [styles.tableHeaderCell, style] },
          (0, _rax.createElement)(
            _raxText2.default,
            null,
            col.title
          )
        );
      });
    }
  }, {
    key: '_renderRow',
    value: function _renderRow(rowData, index) {
      var _props2 = this.props,
          columns = _props2.columns,
          renderCell = _props2.renderCell;

      if (!renderCell) {
        renderCell = this._renderCell.bind(this);
      }
      return (0, _rax.createElement)(
        _raxView2.default,
        { key: index, style: styles.tableRow },
        columns.map(function (col) {
          return renderCell(rowData[col.dataIndex], col);
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props3 = this.props,
          width = _props3.width,
          height = _props3.height,
          style = _props3.style,
          dataSource = _props3.dataSource;

      return (0, _rax.createElement)(
        _raxScrollview2.default,
        {
          style: [style, { width: width, height: height }],
          contentContainerStyle: [style, { width: width, height: height }],
          horizontal: true },
        (0, _rax.createElement)(
          _raxView2.default,
          { style: styles.tableBody },
          (0, _rax.createElement)(
            _raxView2.default,
            { style: styles.tableHeader },
            this._renderHeader()
          ),
          (0, _rax.createElement)(
            _raxScrollview2.default,
            {
              style: styles.tableBody },
            dataSource.map(function (rowData, index) {
              return _this2._renderRow(rowData, index);
            })
          )
        )
      );
    }
  }]);

  return Table;
}(_rax.Component);

Table.defaultProps = {
  columns: [],
  dataSource: [],
  columnWidth: undefined,
  renderCell: undefined,
  height: DEFAULT_HEIGHT
};


var styles = {
  tableHeader: {
    flexDirection: 'row'
  },
  tableHeaderCell: {
    minHeight: 30,
    backgroundColor: '#efefef',
    borderRightWidth: 1,
    borderRightColor: '#dfdfdf',
    alignItems: 'center',
    justifyContent: 'center'
  },
  tableBody: {
    flex: 1
  },
  tableRow: {
    flexDirection: 'row',
    backgroundColor: '#fbfbfb',
    borderBottomWidth: 1,
    borderBottomColor: '#dfdfdf'
  },
  tableCell: {
    minHeight: 50,
    backgroundColor: 'transparent',
    borderRightWidth: 1,
    borderRightColor: '#dfdfdf',
    alignItems: 'center',
    justifyContent: 'center'
  }
};

exports.default = Table;
module.exports = exports['default'];